package com.yihu.wlyy.service;

/**
 * Created by ${liuwenbin} on 2017/8/28.
 */
public interface PrescriptionCAService {

//    String getHeaderXml(String api,String srcBusinessStreamNO,String srcRequestStreamNO);

    /**
     * 生产环境 智业CA接口二次封装
     * @param api
     * @param params
     * @param srcBusinessStreamNO
     * @return
     * @throws Exception
     */
//    public String postZyCaServer(String api, Map<String,String> params, String srcBusinessStreamNO, String content) throws Exception;

    /**
     * 测试环境：CA认证服务二次封装
     */
//    public String postCAServer(String api, Map<String,String> params,String srcBusinessStreamNO) throws Exception;

    /**
     * 请求实名软证书并进行数字签名
     **/
    public String requestRealNameSoftCertAndSign(String strUserIdcardNum, String strRealNameSoftCertCalledPasswd, String strOriginalData, String srcBusinessStreamNO)  throws Exception;


    /**
     * 获取实名软证书的过期时间
     **/
    public String getRealNameSoftCertExpiredDatetime(String strUserIdcardNum, String srcBusinessStreamNO)  throws Exception;

    /**
     * 修改实名软证书调用保护口令
     **/
    public String modifyRealNameSoftCertCalledPasswd(String strUserIdcardNum, String strOldCalledPasswd, String strNewCalledPasswd, String srcBusinessStreamNO) throws Exception;

    /**
     * 验证签名(带多服务器负载均衡)
     **/
    public String verifySignOnMultiServer(String strSignData, String strCertData, String strOriginalData, String srcBusinessStreamNO)  throws Exception;

    /**
     * 判断是否有实名证书
     **/
    public String isApplied(String strUserIdcardNum, String srcBusinessStreamNO)  throws Exception;
}
