package com.yihu.wlyy.entity;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * 
 * his在线处方主表vo
 * </pre>
 * @since 1.
 */
@ApiModel(value = "WlyyHisPrescriptionVO", description = "在线处方主表")
public class WlyyHisPrescriptionVO {
    @ApiModelProperty(value = "id", example = "402803ee656498890165649ad2da1112" )
    protected String id;  // 非业务主键

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }
    /**
     * 卡号
     */
  private String cardNo;
    /**
     * 医生工号
     */
    private String doctor;
    /**
     * 科室编码
     */
    private String dept;
    /**
     * 收费码
     */
    private String chargeCode;
    /**
     * 分部号
     */
    private String winNo;
    /**
     * 项目类别
     */
    private String chargeFlag;
    /**
     * 数量
     */
    private String quantity;
    /**
     * 挂号流水号
     */
    private String serialNo;
    /**
     * 库房号
     */
    private String groupNo;
    /**
     * 药品序列号
     */
    private String serial;
    /**
     * 主诊断编码
     */
    private String icdCode;

    /**
     * 用量
     */
    private String dosage;
    /**
     * 用量单位
     */
    private String unit;
    /**
     * 频率
     */
    private String usage;
    /**
     * 用法
     */
    private String supplyCode;
    /**
     * 天数
     */
    private String days;
    /**
     * 组号
     */
    private String frequency;
    /**
     * 第二诊断
     */
    private String diagTwo;
    /**
     * 第三诊断
     */
    private String diagThree;
    /**
     * 第四诊断
     */
    private String diagFour;
    /**
     * 第五诊断
     */
  private String diagFive;

    public String getCardNo() {
        return cardNo;
    }

    public void setCardNo(String cardNo) {
        this.cardNo = cardNo;
    }

    public String getDoctor() {
        return doctor;
    }

    public void setDoctor(String doctor) {
        this.doctor = doctor;
    }

    public String getDept() {
        return dept;
    }

    public void setDept(String dept) {
        this.dept = dept;
    }

    public String getChargeCode() {
        return chargeCode;
    }

    public void setChargeCode(String chargeCode) {
        this.chargeCode = chargeCode;
    }

    public String getWinNo() {
        return winNo;
    }

    public void setWinNo(String winNo) {
        this.winNo = winNo;
    }

    public String getChargeFlag() {
        return chargeFlag;
    }

    public void setChargeFlag(String chargeFlag) {
        this.chargeFlag = chargeFlag;
    }

    public String getQuantity() {
        return quantity;
    }

    public void setQuantity(String quantity) {
        this.quantity = quantity;
    }

    public String getSerialNo() {
        return serialNo;
    }

    public void setSerialNo(String serialNo) {
        this.serialNo = serialNo;
    }

    public String getGroupNo() {
        return groupNo;
    }

    public void setGroupNo(String groupNo) {
        this.groupNo = groupNo;
    }

    public String getSerial() {
        return serial;
    }

    public void setSerial(String serial) {
        this.serial = serial;
    }

    public String getIcdCode() {
        return icdCode;
    }

    public void setIcdCode(String icdCode) {
        this.icdCode = icdCode;
    }

    public String getDiagTwo() {
        return diagTwo;
    }

    public void setDiagTwo(String diagTwo) {
        this.diagTwo = diagTwo;
    }

    public String getDiagThree() {
        return diagThree;
    }

    public void setDiagThree(String diagThree) {
        this.diagThree = diagThree;
    }

    public String getDiagFour() {
        return diagFour;
    }

    public void setDiagFour(String diagFour) {
        this.diagFour = diagFour;
    }

    public String getDiagFive() {
        return diagFive;
    }

    public void setDiagFive(String diagFive) {
        this.diagFive = diagFive;
    }

    public String getDosage() {
        return dosage;
    }

    public void setDosage(String dosage) {
        this.dosage = dosage;
    }

    public String getUnit() {
        return unit;
    }

    public void setUnit(String unit) {
        this.unit = unit;
    }

    public String getUsage() {
        return usage;
    }

    public void setUsage(String usage) {
        this.usage = usage;
    }

    public String getSupplyCode() {
        return supplyCode;
    }

    public void setSupplyCode(String supplyCode) {
        this.supplyCode = supplyCode;
    }

    public String getDays() {
        return days;
    }

    public void setDays(String days) {
        this.days = days;
    }

    public String getFrequency() {
        return frequency;
    }

    public void setFrequency(String frequency) {
        this.frequency = frequency;
    }


}